local AFFLICTION_TAB=1;
local IMP_LIFETAP_ID=5;
local RANK_MULTIPLIER={0.38,0.68,0.8,0.8,0.8,0.8};
local BASE_DAMAGE={30,75,140,220,310,424};

local function ScaledLifetap_GetLifetapMultiplier()
    local name,iconPath,tier,column,rank = GetTalentInfo(AFFLICTION_TAB, IMP_LIFETAP_ID);
    local multiplier = 1;
    if (name == "Improved Life Tap") then
        if rank == 1 then
            multiplier = 1.1;
        elseif rank == 2 then
            multiplier = 1.2;
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("Talent tree has changed.  Cannot determine Improved Life Tap Rank. Assuming 0 ranks.");
    end
    
    return multiplier;
end

local function ScaledLifetap_GetMaxLifeTapRank()
    local rank=0;
    local count=1;
    local foundSpell = false;
    
    while true do
        local spellName, spellRank = GetSpellName(count, BOOKTYPE_SPELL);
           
        if spellName == "Life Tap" then
            startPos,endPos,rank = string.find(spellRank, "^Rank (.*).*");
            foundSpell = true;
        else
            if foundSpell then
                break;
            end
        end
        count = count + 1;
    end 
    
    --DEFAULT_CHAT_FRAME:AddMessage("Highest rank of Life Tap is " .. rank);
    
    return rank;
end

local function ScaledLifetap_GetDamageBonus()
    local damageBonus = 0;
    if IsAddOnLoaded("BonusScanner") then
        if BonusScanner.bonuses["SHADOWDMG"] then
               damageBonus = BonusScanner.bonuses["SHADOWDMG"] ;
        end
            if BonusScanner.bonuses["DMG"] then
                damageBonus = damageBonus + BonusScanner.bonuses["DMG"];
            end
    end

    --DEFAULT_CHAT_FRAME:AddMessage("Total shadow damage bonus is: " .. damageBonus);

    return damageBonus;
end

function ScaledLifetap_CastLifeTap()
    local damageModifier = ScaledLifetap_GetDamageBonus();
    local lifetapMultiplier = ScaledLifetap_GetLifetapMultiplier();
    local maxRank = ScaledLifetap_GetMaxLifeTapRank();
    local castSpell=false;
    
    for i=maxRank,1,-1 do 
        if(UnitHealth("player")>=BASE_DAMAGE[i]+RANK_MULTIPLIER[i]*damageModifier and (UnitManaMax("player")-UnitMana("player")>=(BASE_DAMAGE[i]+RANK_MULTIPLIER[i]*damageModifier)*lifetapMultiplier)) then 
           CastSpellByName("Life Tap(Rank "..i..")");
          -- DEFAULT_CHAT_FRAME:AddMessage("Casting Life Tap(Rank " .. i .. ")");  
           castSpell = true;
           break;
        end;
    end;
    
    if not castSpell then
        --DEFAULT_CHAT_FRAME:AddMessage("Cancelling Lifetap");
    end
end